unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, pqconnection, sqldb, db, Forms, Controls, Graphics,
  Dialogs, StdCtrls, ComCtrls, DBGrids, Grids;

type
  { Data structure for holding one Product }
  TProduct = record
   id   : integer;
   code : string;
   stock: integer;
   ss   : integer;
  end;

  { Data structure for holding one Customer }
  TCustomer = record
   id   : integer;
   name : string;
  end;

  { Data structure for holding one Order }
  TOrder = record
   id       : integer;
   product  : integer;
   customer : integer;
   quantity : integer;
  end;

  TOrders    = array of TOrder;       { New type that is an array of TOrder }
  TCustomers = array of TCustomer;    { New type that is an array of TCustomer }
  TProducts  = array of TProduct;     { New type that is an array of TProduct }

  { TForm1 }

  TForm1 = class(TForm)
    BtNetwork_UpdateServer: TButton;
    BtNetwork_Query: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    EdNetwork_Query: TEdit;
    EdNetwork_Address: TEdit;
    EdNetwork_Username: TEdit;
    EdNetwork_Password: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    PageControl: TPageControl;
    PQConnection: TPQConnection;
    SQLQuery: TSQLQuery;
    SQLTransaction: TSQLTransaction;
    TabNetwork: TTabSheet;
    procedure BtNetwork_QueryClick(Sender: TObject);
    procedure BtNetwork_UpdateServerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
    procedure DB_Query( cmd : string );
    procedure DB_Execute( cmd : string );
  end;

var
  Form1: TForm1;

  array_orders    : TOrders;     { it will hold several Orders }
  array_customers : TCustomers;  { it will hold several Customers }
  array_products  : TProducts;   { it will hold several Products }
  //DB
  array_products_todelete: TProducts;    { it will hold Products that were deleted }



implementation

{$R *.lfm}

{ TForm1 }





{ Button that inquires the database according to a query in the editbox}
procedure TForm1.BtNetwork_QueryClick(Sender: TObject);
begin
SQLQuery.Close;
 PQConnection.EndTransaction;
 PQConnection.Close;

 DB_Query(EdNetwork_Query.Text);

end;

procedure TForm1.BtNetwork_UpdateServerClick(Sender: TObject);
begin
  PQConnection.UserName:= EdNetwork_Username.Text;
  PQConnection.Password:= EdNetwork_Password.Text;
  PQConnection.HostName:= EdNetwork_Address.Text;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
     BtNetwork_UpdateServerClick(Self);
end;



{ Procedure that executes a cmd to DB which does not returns data}
procedure TForm1.DB_Execute( cmd : string );
begin
  Try
     PQConnection.Connected:= True;
     PQConnection.ExecuteDirect('Begin Work;');
     PQConnection.ExecuteDirect('set idle_in_transaction_session_timeout = 0' );
     PQConnection.ExecuteDirect(cmd);
     PQConnection.ExecuteDirect('Commit Work;');
     PQConnection.Connected:= False;
 except
   on E: EDatabaseError do
      ShowMessage('File handling error occurred. Details: ' +  E.ClassName +  '/' +  E.Message);
   on E : Exception do
      ShowMessage('File handling error occurred. Details: ' +  E.ClassName +  '/' +  E.Message);
 end;
end;

{ Procedure that sends a query defined in ''cmd'' to DB }
procedure TForm1.DB_Query( cmd : string );
begin
  Try
  SQLQuery.Close;

  SQLQuery.SQL.Text:= cmd;

  PQConnection.Connected:= True;

  PQConnection.ExecuteDirect('Begin Work;');

  PQConnection.ExecuteDirect('set idle_in_transaction_session_timeout = 0' );

  PQConnection.ExecuteDirect('Commit Work;');

  SQLTransaction.Active:= True;

  SQLQuery.Open;


   if(PQConnection.Connected) then
   begin
     PQConnection.EndTransaction;
     SQLQuery.Close;    //terminating.
     PQConnection.Close;
   end;
   SQLQuery.SQL.Clear;
   SQLQuery.SQL.Text := cmd;
   PQConnection.Open; //connecting to database
   SQLQuery.Open;     //sending the SQL query to database

 except
   on E: EPQDatabaseError do
      ShowMessage('File handling error occurred. Details: ' +  E.ClassName +  '/' +  E.Message);
 end;
end;

end.

